#! /usr/bin/env python

#################################################
# Python module for converting time axis to slowness axis
# To be used with the envelope output from jcTravelTimePick
# indices are zero-index
#################################################



#################################################
# import
#################################################
import commands
import sys

# run option
run = 1

# definitions
SEPLIB = '/opt/SEP/SEP8.0/bin'

#################################################
# grab the file names
#################################################
def parse_command_line():
  if len(sys.argv) !=5:
    print "Expecting 4 arguments: [header file] [header history file] [absoff index] [station num]"
    sys.exit(-1)
  hf = sys.argv[1]
  hff = sys.argv[2]
  hind = sys.argv[3]
  sta = sys.argv[4]
  
  return hf,hff,hind,sta
    

#################################################
# grab the offset
#################################################
def grab_absoff(hff,hind,sta):
  absoff = 0
  grab_com = 'Window < %s n1=1 f1=%s n2=1 f2=%s | %s/Disfil number=0 format=%%12.4f' %(hff,hind,sta,SEPLIB)
  print grab_com
  if run:
    absoff = commands.getoutput(grab_com)
    print absoff
  
  return absoff


#################################################
# divide the time axis by this distance
#################################################
def set_axes(hf,absoff):
  get1_com = 'Get < %s o1 parform=n' %(hf)
  print get1_com
  if run:
    o1 = commands.getoutput(get1_com)
    print o1
  get2_com = 'Get < %s d1 parform=n' %(hf)
  print get2_com
  if run:
    d1 = commands.getoutput(get2_com) 
    print d1
  os = float(o1)/float(absoff)
  print os
  ds = float(d1)/float(absoff)
  print ds
  echo_com = """echo "o1=%s d1=%s" >> %s""" %(os,ds,hf)
  print echo_com
  if run:
    commands.getoutput(echo_com)


#################################################
#  run commands
#################################################
hf,hff,hind,sta = parse_command_line()
absoff = grab_absoff(hff,hind,sta)
set_axes(hf,absoff)
