program jcXY2cmplx
! Jason P. Chang
! June 2012
!
! convert two real values to a single complex number
! originally for creating a stations map in Grey
! need to window the x and y coordinates
!
! Order: order of x and y coordinates
!   - 1: x is first index, y is second index [default]
!   - 2: y is first index, x is second index
  
  use sep
  implicit none
  
  ! allocate variables
  integer                              :: order
  integer                              :: i
  integer                              :: n1,n2,n3,n4
  real                                 :: o1,o2,o3,o4,d1,d2,d3,d4
  real                                 :: a,b
  complex                              :: out
  real   ,allocatable,dimension   (:)  :: in
  
  ! open I/O
  call sep_init()

  call from_history('n1'   ,n1     )
  call from_history('n2'   ,n2     )
  call from_history('n3'   ,n3     )
  call from_history('n4'   ,n4     )
  call from_history('o1'   ,o1     )
  call from_history('o2'   ,o2     )
  call from_history('o3'   ,o3     )
  call from_history('o4'   ,o4     )
  call from_history('d1'   ,d1     )
  call from_history('d2'   ,d2     )
  call from_history('d3'   ,d3     )
  call from_history('d4'   ,d4     )
  call from_param  ('order',order,1)
  
  call to_history('n1',  n2)
  call to_history('n2',  n3)
  call to_history('n3',  n4)
  call to_history('n4',  1 )
  call to_history('o1',  o2)
  call to_history('o2',  o3)
  call to_history('o3',  o4)
  call to_history('o4',  0.)
  call to_history('d1',  d2)
  call to_history('d2',  d3)
  call to_history('d3',  d4)
  call to_history('d4',  0.)
  call to_history('esize',8)

  call sep_close()

  ! allocate
  allocate(in(n1))

  ! form the complex value
  do i=1,n2*n3*n4

    ! read info
    call sreed('in',in,4*n1)

    if ( order .eq. 1 ) then
      out = cmplx( in(1), in(2) )
    else
      out = cmplx( in(2), in(1) )
    end if

    ! write info
    call srite('out',out,8)
  end do


  ! clean up
  deallocate(in)
  call exit(0)
  
end program jcXY2cmplx
